import { Component, OnInit } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { IsLoginService } from '../../is-login.service'
import { CacheTokenService } from '../../http-interceptors/cache-token.service'
import { MatDialogRef } from '@angular/material/dialog';
import { MatSnackBarConfig, MatSnackBar } from '@angular/material/snack-bar';

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.scss']
})
export class LoginComponent implements OnInit {

  constructor(private http:HttpClient,private isLogin:IsLoginService,private token:CacheTokenService,public dialogRef: MatDialogRef<any>,public snackBar: MatSnackBar) { }

  ngOnInit(): void {

  }

  errmsg:any; //err信息

  //登录
  onSubmit (e) {
    let loginMsg = {
      name: e.name,
      password: e.password
    }
    this.http.post('/api/Account/SignIn',loginMsg).subscribe((data:any)=>{
      sessionStorage.setItem("token",data.token);
      sessionStorage.setItem("refreshToken",data.refreshToken);
      this.token.startUp(); //登陆成功启动定时器刷新token
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('登陆成功','确定',config);
      this.dialogRef.close(data);
    },(err) => {this.errmsg = err})

  }

}
